;;; coding: euc-jp
;;; -*- scheme -*-
;;; vim:set ft=scheme ts=8 sts=2 sw=2 et:
;;; $Id: state.scm 211 2005-10-01 21:34:51Z nekoie $

(define-module tcpcgi.state
  (use gauche.interactive)
  (export
    <tcpcgi.state>
    copy-all-slot!
    clone
    dump-string
    dump-to-error-port
    ))
(select-module tcpcgi.state)


(define-class <tcpcgi.state> ()
  (
   ;; ǽ餫ʬäƤ
   (first-transaction :init-keyword :first-transaction
                      :init-value #t)
   (server-addr :init-keyword :server-addr
                :init-value #f)
   (server-port :init-keyword :server-port
                :init-value #f)
   (server-name :init-keyword :server-name
                :init-value #f)
   (remote-addr :init-keyword :remote-addr
                :init-value #f)
   (remote-port :init-keyword :remote-port
                :init-value #f)
   (remote-host :init-keyword :remote-host
                :init-value #f)
   (https       :init-keyword :https
                :init-value #f)

   ;; ̾
   (response-code :init-value #f) ; 200, 302, 500 ο͡
   (internal-description :init-value #f) ; nph䥨顼ͳ򵭽
   (connection-close :init-value #f) ; 쥹ݥ󥹤֤ƤϤʤ
   (use-persistent-connection :init-value #f) ; ³Ū³Ԥɤ
   (use-keep-alive :init-value #f) ; Connection: Keep-Aliveإå뤫ɤ

   ;; 饤ȤHTTPꥯȤξ
   (request-line :init-value #f) ; "GET / HTTP/1.0" 
   (request-method :init-value #f)
   (request-uri :init-value #f)
   (request-protocol :init-value #f)
   (parsed-uri-list :init-value #f) ; uri-parse֤ͤΥꥹ
   (http-0.9-flag :init-value #f) ; HTTP/0.9ʤ鿿
   (request-header :init-value #f) ; request-line³rfc822Υإå
   (content-type :init-value #f)
   (content-length :init-value #f)
   (request-body :init-value #f) ; ʳǰöɤ߼äƤ

   ;; cgiץȼ¹Իɬפˤʤ
   (dispatched-server-name :init-value #f) ; HTTP_HOSTvhost̾
   (dispatched-script-name :init-value #f) ; dispatchΥץȤpath
   (dispatched-path-info :init-value #f) ; dispatchdecodepath-info
   (dispatched-cgi-target :init-value #f) ; ¹Ԥ٤cgiץ
   (nph :init-value #f) ; cgiץȤnphưԤɤ
   (auth-type :init-value #f) ; ǧڼˡBasic, Digest
   (auth-name :init-value #f) ; ǧڤ̾
   (auth-hash :init-value #f) ; ǧڤ˻Ȥhash-table
   (remote-user :init-value #f) ; ǧڻΥ桼̾
   (plain-cgi-metavariables :init-value #f) ; 줿᥿ѿ
   (merged-cgi-metavariables :init-value #f) ; (cgi-metavariables)ȥޡ

   ;; cgiץȤΥ쥹ݥ󥹤ξ
   (cgi-response :init-value #f) ; cgiϤƤΤ(string)
   (cgi-error-instance :init-value #f) ; ª顼㳰֥
   (cgi-response-header :init-value #f) ; cgi֤rfc822Υإå
   (cgi-response-body :init-value #f) ; ΥإåäĤ

   ;; 饤Ȥ֤HTTP쥹ݥ󥹤ξ
   (response-status-line :init-value #f) ; "HTTP/1.1 200 OK" 
   (response-header :init-value #f) ; status-line³rfc822Υإå
   (response-body :init-value #f) ; ΥإåäĤ
   ))


(define-method copy-all-slot! ((src <tcpcgi.state>) (dst <tcpcgi.state>))
  (for-each
    (lambda (slot-name)
      (set!
        (ref dst slot-name)
        (ref src slot-name)))
    (map slot-definition-name (class-slots <tcpcgi.state>))))


(define-method clone ((self <tcpcgi.state>))
  (let1 new (make <tcpcgi.state>)
    (copy-all-slot! self new)
    new))


(define-method dump-string ((self <tcpcgi.state>))
  (with-output-to-string
    (lambda ()
      (describe self))))

(define-method dump-to-error-port ((self <tcpcgi.state>))
  (with-output-to-port
    (current-error-port)
    (lambda ()
      (describe self))))


(provide "tcpcgi/state")

